<?php if (!defined('PmWiki')) exit();

SDV($CategoryGroup, 'Category');

if ($format=='pdf') {
    if ($ptype=='book') {
    
      $EnableBookIndex = true;

      ## '''[[!Category]]'''
      Markup("''+!", "<'''''", "/(''+)\\[\\[(![^\\]]*?)\\]\\]\\1/e", 
                               "'[['.strlen(PSS('$1')).PSS('$2]]')");

      ## [[!Category]]
      $LinkCategoryFmt = array('ix' => "<tbook:ix>\$LinkParent\$LinkText</tbook:ix>",
                              'ix2' => "<tbook:ix2>\$LinkText</tbook:ix2>",
                              'ixs' => "<tbook:ix sortkey='\$LinkSort'>\$LinkText</tbook:ix>",
                             'ix2s' => "<tbook:ix2 sortkey='\$LinkSort'>\$LinkText</tbook:ix2>");
      Markup('[[!', '<[[', "/\\s*\\[\\[(\\d)?!(.*?)\\]\\]/e",
  "Keep(MakeIndexEntry(NULL,PSS('$2'),'$1',\$GLOBALS['LinkCategoryFmt'],'$CategoryGroup'),'L')");

      ## [[!Category | text]]
      Markup('[[!|', '<[[!', "/(?>\\s*\\[\\[(\\d)?!([^|\\]]*)\\s*\\|\\s*)(!)?(.*?)\\s*\\]\\]/e",
  "Keep(MakeIndexLink('$CategoryGroup','$3',PSS('$4'),PSS('$2'),'$1',\$GLOBALS['LinkCategoryFmt']),'L')");

      ## '''[[$CategoryGroup/Category]]'''
      Markup("''+cat", "<'''''", "/(''+)\\[\\[($CategoryGroup\\/[^\\]]*?)\\]\\]\\1/e",
                                 "'[['.strlen(PSS('$1')).PSS('$2]]')");

      ## [[$CategoryGroup/Category]]
      $LinkShowCategoryFmt = array('ix' => "<tbook:idx>\$LinkText</tbook:idx>",
                                  'ix2' => "",
                                  'ixs' => "<tbook:idx sortkey='\$LinkSort'>\$LinkText</tbook:idx>",
                                 'ix2s' => "");
      Markup('[[cat', '<[[', "/\\[\\[(\\d)?$CategoryGroup\\/([^|()\\]]+)(?:\\s*\\|\\s*(.*?)\\s*)?\\]\\]/e",
  "Keep(MakeIndexEntry(PSS('$3'),PSS('$2'),'$1',\$GLOBALS['LinkShowCategoryFmt']),'L')");


function MakeIndexLink($tgrp,$see=NULL,$txt,$cat,$kind=NULL,$fmtarray=NULL) {
  $ixsee = 'tbook:indexsee';
  return ($see) ? "<$ixsee>".MakeIndexEntry('',$txt,'',$fmtarray,$tgrp).
                             MakeIndexEntry('',$cat,'',$fmtarray,$tgrp)."</$ixsee>" 
                : MakeIndexEntry($txt,$cat,$kind,$fmtarray,$tgrp);
}
function MakeIndexEntry($txt=NULL,$cat=NULL,$kind=NULL,$fmtarray=NULL,$tgrp=NULL) {
  static $IndexStart;
  if (preg_match('/\\((.*?)\\)/', $cat, $p)) {
      $parent = trim($p[1]); $cat = str_replace($p[0], '', $cat);
      $ppage  = MakePageName("$tgrp.$tgrp",$parent);
      $ptitle = PageExists($ppage) ? PageVar($ppage, '$Title') : '';
  } else
      $parent = '';
  $cat = trim($cat);
  $fmt = ($parent) ? $fmtarray['ix'] : ($txt ? $fmtarray['ixs'] : $fmtarray['ix']);
  if ($ptitle) {
      $fmt = str_replace('>$', ' sortkey="'.$parent.'">$', $fmt);
      $parent = $ptitle;
  }
  if ($kind) {
      $k = $kind-2;
      if (@$IndexStart[$cat]) { 
          $k = 2; $IndexStart[$cat] = false;
      } elseif ($k>2) { 
          $k = 3; $IndexStart[$cat] = true; 
      }
      $attr = array('italic', 'bold', 'end', 'start');
      $fmt  = str_replace('>$', ' kind="'.$attr[$k].'">$', $fmt);
  }
  $text = ($txt) ? $fmtarray['ix2s'] : $fmtarray['ix2'];
  $fmt  = str_replace('$LinkParent', $parent, ($parent ? str_replace('$LinkText', $text, $fmt) : $fmt));
  return ($txt) ? str_replace(array('$LinkSort','$LinkText'), array($cat,$txt), $fmt) : 
                  str_replace('$LinkText', $cat, $fmt);
}

    } else {

      ## '''[[!Category]]'''
      Markup("''+!", "<'''''", "/(''+)\\[\\[!([^\\]]*?)\\]\\]\\1/e", 
        "'<tbook:mnote class=\"mnote\">$1'.MarginCategory(PSS('$2')).'$1</tbook:mnote>'");
      Markup("cat!", ">'''''", "/\\[\\[!([^\\]]*?)\\]\\]/e", 
        "'<tbook:mnote class=\"mnote\">'.MarginCategory(PSS('$1')).'</tbook:mnote>'");

      ## '''[[$CategoryGroup/Category]]'''
      Markup("''+cat", "<'''''", "/(''+)\\[\\[$CategoryGroup\\/([^\\]]*?)\\]\\]\\1/e", 
        "'$0<tbook:mnote class=\"mnote\">$1'.MarginCategory(PSS('$2')).'$1</tbook:mnote>'");
      Markup("cat/", ">'''''", "/\\[\\[$CategoryGroup\\/([^\\]]*?)\\]\\]/e", 
        "'$0<tbook:mnote class=\"mnote\">'.MarginCategory(PSS('$1')).'</tbook:mnote>'");
      
      function MarginCategory($cat) {
        if (preg_match('/^([^|]+)\\s*\\|\\s*(!)?(.*)$/', $cat, $c))
            return $c[2] ? IndexSubindex($c[3],$c[3]).': '.IndexSubindex($c[1],$c[1]) : $c[3];
        else
            return IndexSubindex($cat, $cat);
      }

    }
} else {

  ## [[!Category |Text]]
  Markup('[[!','<[[|',"/\\[\\[(?:!|$CategoryGroup\\/)([^|\\]]+)(?:\\s*\\|\\s*(!)?(.*?)\\s*)?\\]\\]/e",
  "Keep(MakeLink(\$pagename,
                 PSS('$CategoryGroup/$1'),
                 ('$3' ? IndexSeeCheck('$2',PSS('$3')) : IndexSubindex(PSS('$1'))),
                 '',
                 \$GLOBALS['LinkCategoryFmt']),'L')");
  function IndexSeeCheck($see=NULL, $cat) {
    return $see ? IndexSubindex($cat, $cat) : $cat;
  }
}
  function IndexSubindex($cat, $r=NULL) {
    if (preg_match('/\\((.*?)\\)/', $cat, $p)) $r = trim($p[1]).', '.str_replace($p[0], '', $cat);
    return $r;
  }

?>
